import java.util.*;

public class DecreasingProcessTime{
	static DecreasingProcessTime[] cache_keys = new DecreasingProcessTime[128];
	static Object[] cache_values = new Object[128];
	static Hashtable<Object,Object> hash = new Hashtable<Object,Object>();
	static int freeIndex = 0;
	int cacheRef = -1;
	int value;
	public static void main(String[] args){
		try{
			System.out.println("started populating");
			populate();
			System.out.println("started accessing");
			access_DecreasingProcessTime();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	public DecreasingProcessTime(int i){
		value = i;
	}
	public int hashCode(){
		return value;
	}
	public boolean equals(Object obj){
		if((obj != null) && (obj instanceof DecreasingProcessTime))
			return value == ((DecreasingProcessTime) obj).value;
		else
			return false;
	}
	public static void populate(){
		for (int i = 0; i < 100000; i++)
			hash.put(new DecreasingProcessTime(i), new Integer(i+5));
	}
	public static Object plain_access(DecreasingProcessTime i){
		return hash.get(i);
	}
	public static Object cached_access(DecreasingProcessTime i){
		int access = i.cacheRef;
		Object o;
		if(access == -1){
			o = hash.get(i);
			if(freeIndex >= cache_keys.length)
				freeIndex = 0;
			access = i.cacheRef = freeIndex++;
			if (cache_keys[access] != null){
				System.out.println("Collsion between " + cache_keys[access] + " and " + i);
				cache_keys[access].cacheRef = -1;
			}
			cache_keys[access] = i;
			cache_values[access] = o;
			return o;
		}
		else{
			return cache_values[access];
		}
	}
	
	public static void access_DecreasingProcessTime(){
		DecreasingProcessTime a0 = new DecreasingProcessTime(6767676);
		DecreasingProcessTime a1 = new DecreasingProcessTime(33);
		DecreasingProcessTime a2 = new DecreasingProcessTime(998);
		DecreasingProcessTime a3 = new DecreasingProcessTime(3333);
		DecreasingProcessTime a4 = new DecreasingProcessTime(12348765);
		DecreasingProcessTime a5 = new DecreasingProcessTime(9999);
		DecreasingProcessTime a6 = new DecreasingProcessTime(66665);
		DecreasingProcessTime a7 = new DecreasingProcessTime(1234);
		DecreasingProcessTime a8 = new DecreasingProcessTime(987654);
		DecreasingProcessTime a9 = new DecreasingProcessTime(3121219);
		Object o1,o2,o3,o4,o5,o6,o7,o8,o9,o0;
		long time = System.currentTimeMillis();
		for(int i = 0; i < 1000000; i++){
			o1 = plain_access(a0);
			o2 = plain_access(a1);
			o3 = plain_access(a2);
			o4 = plain_access(a3);
			o5 = plain_access(a4);
			o6 = plain_access(a5);
			o7 = plain_access(a6);
			o8 = plain_access(a7);
			o9 = plain_access(a8);
			o0 = plain_access(a9);
		}
		System.out.println("plain access took " + (System.currentTimeMillis( )-time));
		time = System.currentTimeMillis();
		for(int i = 0; i < 1000000; i++){
			o1 = cached_access(a0);
			o2 = cached_access(a1);
			o3 = cached_access(a2);
			o4 = cached_access(a3);
			o5 = cached_access(a4);
			o6 = cached_access(a5);
			o7 = cached_access(a6);
			o8 = cached_access(a7);
			o9 = cached_access(a8);
			o0 = cached_access(a9);
		}
		System.out.println("cached access took " + (System.currentTimeMillis()-time));
	}
}